import React from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';

/**
  * This is `MyComponent`, and this is a description for it
  */
var Button = function Button(_ref) {
  var label = _ref.label,
      _onClick = _ref.onClick,
      _ref$primary = _ref.primary,
      primary = _ref$primary === undefined ? false : _ref$primary,
      _ref$round = _ref.round,
      round = _ref$round === undefined ? false : _ref$round;

  return React.createElement(
    Container,
    { primary: primary, round: round, onClick: function onClick() {
        return _onClick;
      } },
    React.createElement(
      'span',
      null,
      label
    )
  );
};

var Container = styled.div.withConfig({
  displayName: 'Button__Container',
  componentId: 'bmcxgo-0'
})(['background:', ';color:', ';min-width:50px;max-width:300px;border-radius:', ';display:inline-block;text-align:center;padding:12px 24px;cursor:pointer;user-select:none;font-weight:500;font-size:15px;text-transform:uppercase;letter-spacing:.025em;box-shadow:0 4px 6px rgba(50,50,93,.11),0 1px 3px rgba(0,0,0,.08);transform:translateY(0px);transition:all .15s ease;opacity:.9;&:hover{transform:translateY(-1px);box-shadow:0 7px 14px rgba(50,50,93,.1),0 3px 6px rgba(0,0,0,.08);opacity:.8;}&:active,&:focus{transform:translateY(1px);box-shadow:0 4px 6px rgba(50,50,93,.11),0 1px 3px rgba(0,0,0,.08);opacity:1;}'], function (props) {
  return props.primary ? '#1787e6' : '#f1f3f5';
}, function (props) {
  return props.primary ? '#f1f3f5' : '#3e4c5a';
}, function (props) {
  return props.round ? '500px' : '4px';
});

Button.propType = {
  label: PropTypes.string.isRequired,
  onClick: PropTypes.func.isRequired,
  primary: PropTypes.bool,
  round: PropTypes.bool
};

var Colors = {
  primary: '#68A3E7'
};

/** SVG Eye Icon */
function Icon() {
  // Attribution: Fabián Alexis at https://commons.wikimedia.org/wiki/File:Antu_view-preview.svg
  return React.createElement(
    "svg",
    { width: "16", height: "16", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 22 22" },
    React.createElement(
      "g",
      { transform: "matrix(.02146 0 0 .02146 1 1)", fill: "#4d4d4d" },
      React.createElement("path", { d: "m466.07 161.53c-205.6 0-382.8 121.2-464.2 296.1-2.5 5.3-2.5 11.5 0 16.9 81.4 174.9 258.6 296.1 464.2 296.1 205.6 0 382.8-121.2 464.2-296.1 2.5-5.3 2.5-11.5 0-16.9-81.4-174.9-258.6-296.1-464.2-296.1m0 514.7c-116.1 0-210.1-94.1-210.1-210.1 0-116.1 94.1-210.1 210.1-210.1 116.1 0 210.1 94.1 210.1 210.1 0 116-94.1 210.1-210.1 210.1" }),
      React.createElement("circle", { cx: "466.08", cy: "466.02", r: "134.5" })
    )
  );
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};









var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var ProgressBar = function (_React$Component) {
  inherits(ProgressBar, _React$Component);

  function ProgressBar() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, ProgressBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).call.apply(_ref, [this].concat(args))), _this), _this.getColor = function (percent) {
      console.log('percent', _this.props.percent);
      if (_this.props.percent === 100) return 'green';
      return _this.props.percent > 50 ? 'lightgreen' : 'red';
    }, _this.get_width_as_percent_of_totdal_width = function () {
      console.log(parseInt(_this.props.width * (_this.props.percent / 100), 10));
      return parseInt(_this.props.width * (_this.props.percent / 100), 10);
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(ProgressBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          percent = _props.percent,
          width = _props.width,
          height = _props.height;

      return React.createElement(
        Container$1,
        { width: width },
        React.createElement(Progress, { width: this.get_width_as_percent_of_totdal_width(), backgroundColor: this.getColor(percent) })
      );
    }
  }]);
  return ProgressBar;
}(React.Component);

ProgressBar.propTypes = {
  /** Percent of progress completed */
  percent: PropTypes.number.isRequired,

  /** Bar width */
  width: PropTypes.number.isRequired,

  /** Bar height */
  height: PropTypes.number
};

ProgressBar.defaultProps = {
  height: 5
};

var Container$1 = styled.div.withConfig({
  displayName: 'ProgressBar__Container',
  componentId: 'usjzm8-0'
})(['width:', 'px;border:1px solid #f2efef;border-radius:50px;margin-top:5px;'], function (props) {
  return props.width;
});
var Progress = styled.div.withConfig({
  displayName: 'ProgressBar__Progress',
  componentId: 'usjzm8-1'
})(['width:', 'px;border-radius:50px;height:5px;background-color:', ';'], function (props) {
  return props.width;
}, function (props) {
  return props.backgroundColor;
});

/** Label with required field display, htmlFor, and block styling */
function Label(_ref) {
  var htmlFor = _ref.htmlFor,
      label = _ref.label,
      _ref$required = _ref.required,
      required = _ref$required === undefined ? false : _ref$required;

  return React.createElement(
    LabelStyle,
    { style: { display: 'block' }, htmlFor: htmlFor },
    label,
    ' ',
    required && React.createElement(
      'span',
      { style: { color: 'red' } },
      ' *'
    )
  );
}

var LabelStyle = styled.label.withConfig({
  displayName: 'Label__LabelStyle',
  componentId: 's1ng7gq3-0'
})(['color:#788692;font-weight:300;font-size:14px;']);

Label.propTypes = {
  htmlFor: PropTypes.string.isRequired,
  label: PropTypes.string.isRequired,
  required: PropTypes.bool
};

//components
/** Text input with integrated label to enforce consistency in layout, error display, label placement, and required field marker. */
function TextInput(_ref) {
  var htmlId = _ref.htmlId,
      name = _ref.name,
      label = _ref.label,
      _ref$type = _ref.type,
      type = _ref$type === undefined ? "text" : _ref$type,
      _ref$required = _ref.required,
      required = _ref$required === undefined ? false : _ref$required,
      onChange = _ref.onChange,
      placeholder = _ref.placeholder,
      value = _ref.value,
      error = _ref.error,
      children = _ref.children,
      props = objectWithoutProperties(_ref, ['htmlId', 'name', 'label', 'type', 'required', 'onChange', 'placeholder', 'value', 'error', 'children']);

  console.log(htmlId, name, label);
  return React.createElement(
    Container$2,
    null,
    React.createElement(Label, { htmlFor: htmlId, label: label, required: required }),
    React.createElement(Input, _extends({
      id: htmlId,
      type: type,
      name: name,
      placeholder: placeholder,
      value: value,
      onChange: onChange,
      style: error && { border: 'solid 1px red' }
    }, props)),
    children,
    error && React.createElement(
      Error,
      null,
      error
    )
  );
}

var Container$2 = styled.div.withConfig({
  displayName: 'TextInput__Container',
  componentId: 'pzpffy-0'
})(['margin-bottom:16px;position:relative;']);

var Input = styled.input.withConfig({
  displayName: 'TextInput__Input',
  componentId: 'pzpffy-1'
})(['color:#162d3d;font-size:16px;min-width:20px;height:36px;line-height:34px;padding:0 12px;border:1px solid #c1e4fe;border-radius:4px;background-color:#ffffff;&:hover{background-color:#eaf7ff;}&:focus{outline:-webkit-focus-ring-color auto 5px;}']);
var Error = styled.div.withConfig({
  displayName: 'TextInput__Error',
  componentId: 'pzpffy-2'
})(['color:#ce0202bd;font-size:14px;']);

TextInput.propTypes = {
  /** Unique HTML ID. Used for tying label to HTML input. Handy hook for automated testing. */
  htmlId: PropTypes.string.isRequired,

  /** Input name. Recommend setting this to match object's property so a single change handler can be used. */
  name: PropTypes.string.isRequired,

  /** Input label */
  label: PropTypes.string.isRequired,

  /** Input type */
  type: PropTypes.oneOf(['text', 'number', 'password']),

  /** Mark label with asterisk if set to true */
  required: PropTypes.bool,

  /** Function to call onChange */
  onChange: PropTypes.func.isRequired,

  /** Placeholder to display when empty */
  placeholder: PropTypes.string,

  /** Value */
  value: PropTypes.any,

  /** String to display when error occurs */
  error: PropTypes.string,

  /** Child component to display next to the input */
  children: PropTypes.node
};

/** Password input with integrated label, quality tips, and show password toggle. */

var PasswordInput = function (_React$Component) {
  inherits(PasswordInput, _React$Component);

  function PasswordInput(props) {
    classCallCheck(this, PasswordInput);

    var _this = possibleConstructorReturn(this, (PasswordInput.__proto__ || Object.getPrototypeOf(PasswordInput)).call(this, props));

    _this.toggleShowPassword = function (event) {
      _this.setState(function (prevState) {
        return { showPassword: !prevState.showPassword };
      });
      if (event) event.preventDefault();
    };

    _this.state = {
      showPassword: false
    };
    return _this;
  }

  createClass(PasswordInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          htmlId = _props.htmlId,
          value = _props.value,
          label = _props.label,
          error = _props.error,
          onChange = _props.onChange,
          placeholder = _props.placeholder,
          maxLength = _props.maxLength,
          showVisibilityToggle = _props.showVisibilityToggle,
          quality = _props.quality,
          props = objectWithoutProperties(_props, ['htmlId', 'value', 'label', 'error', 'onChange', 'placeholder', 'maxLength', 'showVisibilityToggle', 'quality']);
      var showPassword = this.state.showPassword;


      return React.createElement(
        TextInput,
        _extends({
          htmlId: htmlId,
          label: label,
          placeholder: placeholder,
          type: showPassword ? 'text' : 'password',
          onChange: onChange,
          value: value,
          maxLength: maxLength,
          error: error,
          required: true
        }, props),
        showVisibilityToggle && React.createElement(
          IconWrap,
          null,
          React.createElement(
            'a',
            { href: '',
              onClick: this.toggleShowPassword },
            React.createElement(Icon, null)
          )
        ),
        value.length > 0 && quality && React.createElement(ProgressBar, { percent: quality, width: 130 })
      );
    }
  }]);
  return PasswordInput;
}(React.Component);

var IconWrap = styled.div.withConfig({
  displayName: 'PasswordInput__IconWrap',
  componentId: 's1xm9whk-0'
})(['margin-right:10px;top:26px;position:absolute;right:0;']);

PasswordInput.propTypes = {
  /** Unique HTML ID. Used for tying label to HTML input. Handy hook for automated testing. */
  htmlId: PropTypes.string.isRequired,

  /** Input name. Recommend setting this to match object's property so a single change handler can be used by convention.*/
  name: PropTypes.string.isRequired,

  /** Password value */
  value: PropTypes.any,

  /** Input label */
  label: PropTypes.string,

  /** Function called when password input value changes */
  onChange: PropTypes.func.isRequired,

  /** Max password length accepted */
  maxLength: PropTypes.number,

  /** Placeholder displayed when no password is entered */
  placeholder: PropTypes.string,

  /** Set to true to show the toggle for displaying the currently entered password */
  showVisibilityToggle: PropTypes.bool,

  /** Display password quality visually via ProgressBar, accepts a number between 0 and 100 */
  quality: PropTypes.number,

  /** Validation error to display */
  error: PropTypes.string
};

PasswordInput.defaultProps = {
  maxLength: 50,
  showVisibilityToggle: false,
  label: 'Password'
};

/** Registration form with built-in validation. */

var RegistrationForm = function (_React$Component) {
  inherits(RegistrationForm, _React$Component);

  function RegistrationForm(props) {
    classCallCheck(this, RegistrationForm);

    var _this = possibleConstructorReturn(this, (RegistrationForm.__proto__ || Object.getPrototypeOf(RegistrationForm)).call(this, props));

    _this.onChange = function (event) {
      var user = _this.state.user;
      user[event.target.name] = event.target.value;
      _this.setState({ user: user });
    };

    _this.onSubmit = function () {
      var user = _this.state.user;

      var formIsValid = _this.validate(user);
      if (formIsValid) {
        _this.props.onSubmit(user);
        _this.setState({ submitted: true });
      }
    };

    _this.state = {
      user: {
        email: '',
        password: ''
      },
      errors: {},
      submitted: false
    };
    return _this;
  }

  createClass(RegistrationForm, [{
    key: 'passwordQuality',


    // Returns a number from 0 to 100 that represents password quality.
    // For simplicity, just returning % of min length entered.
    // Could enhance with checks for number, special char, unique characters, etc.
    value: function passwordQuality(password) {
      if (!password) return null;
      if (password.length >= this.props.minPasswordLength) return 100;
      var percentOfMinLength = parseInt(password.length / this.props.minPasswordLength * 100, 10);
      return percentOfMinLength;
    }
  }, {
    key: 'validate',
    value: function validate(_ref) {
      var email = _ref.email,
          password = _ref.password;

      var errors = {};
      var minPasswordLength = this.props.minPasswordLength;


      if (!email) errors.email = 'Email required.';
      if (password.length < minPasswordLength) errors.password = 'Password must be at least ' + minPasswordLength + ' characters.';

      this.setState({ errors: errors });
      var formIsValid = Object.getOwnPropertyNames(errors).length === 0;
      return formIsValid;
    }
  }, {
    key: 'render',
    value: function render() {
      var _state = this.state,
          errors = _state.errors,
          submitted = _state.submitted;
      var _state$user = this.state.user,
          email = _state$user.email,
          password = _state$user.password;


      return submitted ? React.createElement(
        'h2',
        null,
        this.props.confirmationMessage
      ) : React.createElement(
        Container$3,
        null,
        React.createElement(TextInput, {
          htmlId: 'registration-form-email',
          name: 'email',
          onChange: this.onChange,
          label: 'Email',
          value: email,
          error: errors.email,
          required: true }),
        React.createElement(PasswordInput, {
          htmlId: 'registration-form-password',
          name: 'password',
          value: password,
          onChange: this.onChange,
          quality: this.passwordQuality(password),
          showVisibilityToggle: true,
          maxLength: 50,
          error: errors.password }),
        React.createElement(Button, { primary: true, label: 'Register', onClick: this.onSubmit })
      );
    }
  }]);
  return RegistrationForm;
}(React.Component);

var Container$3 = styled.div.withConfig({
  displayName: 'RegistrationForm__Container',
  componentId: 'giwkgg-0'
})(['display:flex;flex-direction:column;align-items:center;max-width:450px;margin:0 auto;padding:40px;']);

RegistrationForm.propTypes = {
  /** Message displayed upon successful submission */
  confirmationMessage: PropTypes.string,

  /** Called when form is submitted */
  onSubmit: PropTypes.func.isRequired,

  /** Minimum password length */
  minPasswordLength: PropTypes.number
};

RegistrationForm.defaultProps = {
  confirmationMessage: "Thanks for registering!",
  minPasswordLength: 8
};

export { Button, Colors, Icon, ProgressBar, Label, TextInput, PasswordInput, RegistrationForm };
